#include "camera.h"

/************************************************************/
/* LIGHT, TEXTURES & SHADER.                                */
/************************************************************/
/*
void glhLookAtf2( float *matrix, float *eyePosition3D,
                  float *center3D, float *upVector3D )
{
   float forward[3], side[3], up[3];
   float matrix2[16], resultMatrix[16];
   // --------------------
   forward[0] = center3D[0] - eyePosition3D[0];
   forward[1] = center3D[1] - eyePosition3D[1];
   forward[2] = center3D[2] - eyePosition3D[2];
   NormalizeVector(forward);
   // --------------------
   // Side = forward x up
   ComputeNormalOfPlane(side, forward, upVector3D);
   NormalizeVector(side);
   --------------------
   // Recompute up as: up = side x forward
   ComputeNormalOfPlane(up, side, forward);
   // --------------------
   matrix2[0] = side[0];
   matrix2[4] = side[1];
   matrix2[8] = side[2];
   matrix2[12] = 0.0;
   // --------------------
   matrix2[1] = up[0];
   matrix2[5] = up[1];
   matrix2[9] = up[2];
   matrix2[13] = 0.0;
   // --------------------
   matrix2[2] = -forward[0];
   matrix2[6] = -forward[1];
   matrix2[10] = -forward[2];
   matrix2[14] = 0.0;
   // --------------------
   matrix2[3] = matrix2[7] = matrix2[11] = 0.0;
   matrix2[15] = 1.0;
   // --------------------
   MultiplyMatrices4by4OpenGL_FLOAT(resultMatrix, matrix, matrix2);
   glhTranslatef2(resultMatrix,
                  -eyePosition3D[0], -eyePosition3D[1], -eyePosition3D[2]);
   // --------------------
   memcpy(matrix, resultMatrix, 16*sizeof(float));
}
*/
/****************************************/
/* Texture model.                       */
/****************************************/
void TEXTURE_MODEL(void) {
int w, h, c;
   glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
   // Load texture map for cone.
   data = PGM_FILE_READ_1D("./brick.ppm", &w, &h, &c); 
   glGenTextures(1, &ConeMap);
   glBindTexture(GL_TEXTURE_2D, ConeMap);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT); 
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_R, GL_REPEAT); 
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR); 
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
   glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB8, w, h, 0, GL_RGB, GL_UNSIGNED_BYTE, data);
   free(data);
   // Load texture map for cube.
   data = PGM_FILE_READ_1D("./Ron.ppm", &w, &h, &c); 
   glGenTextures(1, &RonMap);
   glBindTexture(GL_TEXTURE_2D, RonMap);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_R, GL_CLAMP_TO_EDGE);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR); 
   glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB8, w, h, 0, GL_RGB, GL_UNSIGNED_BYTE, data);
   free(data);
   // Load texture map for sphere.
   data = PGM_FILE_READ_1D("./earth.ppm", &w, &h, &c); 
   glGenTextures(1, &EarthMap);
   glBindTexture(GL_TEXTURE_2D, EarthMap);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_R, GL_CLAMP_TO_EDGE);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR); 
   glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB8, w, h, 0, GL_RGB, GL_UNSIGNED_BYTE, data);
   free(data);
   // Load texture map for sphere.
   data = PGM_FILE_READ_1D("./moon.ppm", &w, &h, &c); 
   glGenTextures(1, &MoonMap);
   glBindTexture(GL_TEXTURE_2D, MoonMap);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_R, GL_CLAMP_TO_EDGE);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR); 
   glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB8, w, h, 0, GL_RGB, GL_UNSIGNED_BYTE, data);
   free(data);
}

/****************************************/
/* Lighting model.                      */
/****************************************/
void LIGHT_MODEL(void) {
GLfloat ambient[]    = {0.1, 0.1, 0.1, 1.0}; 		// Ambient
GLfloat diffuseD[]   = {0.0, 0.8, 1.0, 1.0};		// Diffuse
GLfloat PositionD[]  = {lightX, lightY, lightZ, 1.0};
GLfloat specularS[]  = {1.0, 0.0, 0.0, 1.0}; 		// Specular
GLfloat PositionS[]  = {1000.0, 0.0, 200.0, 1.0};
GLfloat direction[]  = {  -1.0, 0.3,  -0.3};
   glutSetWindow(vuport);
   glLoadIdentity();
   glLightModeli(GL_LIGHT_MODEL_COLOR_CONTROL, GL_SINGLE_COLOR); 
   glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_FALSE);
   // Ambient "light source".
   glColorMaterial(GL_FRONT, GL_AMBIENT);
   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambient);
   glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
   // Diffuse light source.
   glColorMaterial(GL_FRONT, GL_DIFFUSE);
   glLightfv(GL_LIGHT1, GL_DIFFUSE,  diffuseD);
   glLightfv(GL_LIGHT1, GL_POSITION, PositionD);
   // Specular light source.
   glColorMaterial(GL_FRONT, GL_SPECULAR);
   glLightfv(GL_LIGHT2, GL_DIFFUSE,  specularS);
   glLightfv(GL_LIGHT2, GL_SPECULAR, specularS);
   glLightfv(GL_LIGHT2, GL_POSITION, PositionS);
   glLightfv(GL_LIGHT2, GL_SPOT_DIRECTION, direction);
//   glLightf(GL_LIGHT2, GL_CONSTANT_ATTENUATION, 1.5);
//   glLightf(GL_LIGHT2, GL_LINEAR_ATTENUATION, 0.5);
//   glLightf(GL_LIGHT2, GL_QUADRATIC_ATTENUATION, 0.2);
   glLightf(GL_LIGHT2, GL_SPOT_CUTOFF, spotWidth);
   glLightf(GL_LIGHT2, GL_SPOT_EXPONENT, 5.0);  
   glutSetWindow(window);
}

/************************************************************/
/* THE SCENE.                                               */
/************************************************************/
/****************************************/
/* Draws a copper cone on the screen.   */
/*      v1                              */
/*     /  \                             */
/*    /    \                            */
/*   /      \                           */
/*  v2------v3                          */
/* Note that in cone0, we drew the cone */
/* using triangles, but if we want to   */
/* texture map the cone (texture each   */
/* triangle) we have to use quads to    */
/* draw the triangles!                  */
/*     v1v0                             */
/*     /  \                             */
/*    /    \                            */
/*   /      \                           */
/*  v2------v3                          */
/* Note that we do NOT want to smooth   */
/* shade this cone as we will texture   */
/* map it. So we can draw it using a    */
/* much simpler approach.               */
/****************************************/
void DRAW_CONE(int x, int y, int z, int scale) {
int r;
GLfloat X, x1, x2, x3;
GLfloat Y, y1, y2, y3;
GLfloat Z, z1, z2, z3;
GLfloat mag;
double  angleStep, angle1, angle2;
GLfloat matAmbient[]   = {0.19125, 0.0735,  0.025,    1.0};
GLfloat matDiffuse[]   = {0.7038,  0.27048, 0.0828,   1.0};
GLfloat matSpecular[]  = {0.256777,0.137662,0.086014, 1.0};
GLfloat matShininess[] = {12.8};
   // Adjust location and view angle.
   glPushMatrix();
   glTranslated(x, y, z);
   glRotated(yAngle, 0, 1, 0);  // CW from above (YAW)
   glRotated(pAngle, 0, 0, 1);  // CW from viewer (PITCH)
   glRotated(rAngle, 1, 0, 0);  // CW from side (ROLL)
   // Set material properties.
   glMaterialfv(GL_FRONT, GL_AMBIENT,   matAmbient);
   glMaterialfv(GL_FRONT, GL_DIFFUSE,   matDiffuse);
   glMaterialfv(GL_FRONT, GL_SPECULAR,  matSpecular);
   glMaterialfv(GL_FRONT, GL_SHININESS, matShininess);
   // Build a cone.
   angleStep = (2.0*pi) / (double)(faces-1);
   angle1 = 0.0;
   for (r = 1; r < faces; r++) {
       angle2 += angleStep;
       x1 = 0.0;						// vertix 1 (CCW)
       y1 = 0.0;
       z1 = scale;
       x2 = 0.5 * scale * cos(angle1);	// vertix 2
       y2 = 0.5 * scale * sin(angle1);
       z2 = 0.0;  			
       x3 = 0.5 * scale * cos(angle2);	// vertix 3
       y3 = 0.5 * scale * sin(angle2);
       z3 = 0.0;
       // Determine normal (UNIT!) vector.
       X = (y2-y1)*(z3-z1) - (z2-z1)*(y3-y1);
       Y = (z2-z1)*(x3-x1) - (x2-x1)*(z3-z1);
       Z = (x2-x1)*(y3-y1) - (y2-y1)*(x3-x1);
       // Draw (forcing the texture to replicate 4 times)
       glBegin(GL_QUADS);
         glNormal3f(X, Y, Z);	
         glTexCoord2i(0, 0); 
         glVertex3f(x1, y1, z1);
         glTexCoord2i(1, 0); 
         glVertex3f(x1, y1, z1);
         glTexCoord2i(1, 4); 
         glVertex3f(x2, y2, z2); 
         glTexCoord2i(0, 4); 
         glVertex3f(x3, y3, z3);
       glEnd();
       angle1 = angle2;
   }
   glPopMatrix();
}

/****************************************/
/* Draw a gold sphere on the screen.    */
/****************************************/
void DRAW_SPHERE(int x, int y, int z, int scale) {
int sphereID;
GLfloat matAmbient[]   = {0.24725,  0.1995,   0.0745,    1.0};
GLfloat matDiffuse[]   = {0.75164,  0.60648,  0.22648,   1.0};
GLfloat matSpecular[]  = {0.628281, 0.555802, 0.366065,  1.0};
GLfloat matShininess[] = {51.2};
   // Adjust location and view angle.
   glPushMatrix();
   glTranslated(x, y, z);
   glRotated(pAngle, 0, 1, 0);  // CW from above (YAW)
   glRotated(     0, 0, 0, 1);  // CW from viewer (PITCH)
   glRotated(    90, 1, 0, 0);  // CW from side (ROLL)
   // Set material properties (gold).
   glMaterialfv(GL_FRONT, GL_AMBIENT,   matAmbient);
   glMaterialfv(GL_FRONT, GL_DIFFUSE,   matDiffuse);
   glMaterialfv(GL_FRONT, GL_SPECULAR,  matSpecular);
   glMaterialfv(GL_FRONT, GL_SHININESS, matShininess);
   // Build a sphere.
   GLUquadricObj *sphere = gluNewQuadric();
   gluQuadricDrawStyle(sphere, GLU_FILL);
   gluQuadricTexture(sphere, GL_TRUE);
   if (shader == 0) gluQuadricNormals(sphere, GLU_FLAT);
               else gluQuadricNormals(sphere, GLU_SMOOTH);
   gluSphere(sphere, scale, faces, faces);
   gluDeleteQuadric(sphere);
   glPopMatrix();
}

/****************************************/
/* Draw a polished silver cube on the   */
/* screen.                              */
/*    v6----- v5                        */
/*   /|      /|                         */
/*  v1------v0|                         */
/*  | |     | |                         */
/*  | |v7---|-|v4                       */
/*  |/      |/                          */
/*  v2------v3                          */
/* Here we do it the easy way. We       */
/* specify each surface using two arrays*/
/* for the corners and normals.         */
/****************************************/
void DRAW_CUBE1(int x, int y, int z, int scale) {
int i; 
// vertex coords array
GLfloat vertices[] = 
{ 1, 1, 1,  -1, 1, 1,  -1,-1, 1,   1,-1, 1,    // v0-v1-v2-v3
  1, 1, 1,   1,-1, 1,   1,-1,-1,   1, 1,-1,    // v0-v3-v4-v5
  1, 1, 1,   1, 1,-1,  -1, 1,-1,  -1, 1, 1,    // v0-v5-v6-v1
 -1, 1, 1,  -1, 1,-1,  -1,-1,-1,  -1,-1, 1,    // v1-v6-v7-v2
 -1,-1,-1,   1,-1,-1,   1,-1, 1,  -1,-1, 1,    // v7-v4-v3-v2
  1,-1,-1,  -1,-1,-1,  -1, 1,-1,   1, 1,-1};   // v4-v7-v6-v5
// normal array
GLfloat normals[] = 
{ 0, 0, 1,   0, 0, 1,   0, 0, 1,   0, 0, 1,    // v0-v1-v2-v3
  1, 0, 0,   1, 0, 0,   1, 0, 0,   1, 0, 0,    // v0-v3-v4-v5
  0, 1, 0,   0, 1, 0,   0, 1, 0,   0, 1, 0,    // v0-v5-v6-v1
 -1, 0, 0,  -1, 0, 0,  -1, 0, 0,  -1, 0, 0,    // v1-v6-v7-v2
  0,-1, 0,   0,-1, 0,   0,-1, 0,   0,-1, 0,    // v7-v4-v3-v2
  0, 0,-1,   0, 0,-1,   0, 0,-1,   0, 0,-1};   // v4-v7-v6-v5
GLfloat matAmbient[]   = {0.25,     0.25,     0.25,     1.0};
GLfloat matDiffuse[]   = {0.4,      0.4,      0.4,      1.0};
GLfloat matSpecular[]  = {0.774597, 0.774597, 0.774597, 1.0};
GLfloat matShininess[] = {76.8};
   // Set material properties.
   glMaterialfv(GL_FRONT, GL_AMBIENT,   matAmbient);
   glMaterialfv(GL_FRONT, GL_DIFFUSE,   matDiffuse);
   glMaterialfv(GL_FRONT, GL_SPECULAR,  matSpecular);
   glMaterialfv(GL_FRONT, GL_SHININESS, matShininess);
   // Scale and color the cube .
   for (i = 0; i < 72; i++) {
       vertices[i] *= scale; // scale coords.
   }
   // Build a cube using vertex arrays.
   glEnableClientState(GL_NORMAL_ARRAY);
   glEnableClientState(GL_VERTEX_ARRAY);
   glNormalPointer(GL_FLOAT, 0, normals);
   glVertexPointer(3, GL_FLOAT, 0, vertices);
   // Adjust location and view angle.
   glPushMatrix();
   glTranslated(x, y, z);
   glRotated(yAngle, 0, 1, 0);  // CW from above (YAW)
   glRotated(pAngle, 0, 0, 1);  // CW from viewer (PITCH)
   glRotated(rAngle, 1, 0, 0);  // CW from side (ROLL)
   glDrawArrays(GL_QUADS, 0, 24);
   glDisableClientState(GL_VERTEX_ARRAY); 
   glDisableClientState(GL_NORMAL_ARRAY);
   glPopMatrix();
}

/****************************************/
/* Draw a polished silver cube on the   */
/* screen.                              */
/*    v6----- v5                        */
/*   /|      /|                         */
/*  v1------v0|                         */
/*  | |     | |                         */
/*  | |v7---|-|v4                       */
/*  |/      |/                          */
/*  v2------v3                          */
/* Here we do it the hard way. We       */
/* specify each surface using seperate  */
/* quads.                               */
/****************************************/
void DRAW_CUBE2(int x, int y, int z, int scale) {
GLfloat matAmbient[]   = {0.25,     0.25,     0.25,     1.0};
GLfloat matDiffuse[]   = {0.4,      0.4,      0.4,      1.0};
GLfloat matSpecular[]  = {0.774597, 0.774597, 0.774597, 1.0};
GLfloat matShininess[] = {76.8};
   // Adjust location and view angle.
   glPushMatrix();
   glTranslated(x, y, z);
   glRotated(yAngle, 0, 1, 0);  // CW from above (YAW)
   glRotated(pAngle, 0, 0, 1);  // CW from viewer (PITCH)
   glRotated(rAngle, 1, 0, 0);  // CW from side (ROLL)
   glScaled(scale, scale, scale);
   // Set material properties.
   glMaterialfv(GL_FRONT, GL_AMBIENT,   matAmbient);
   glMaterialfv(GL_FRONT, GL_DIFFUSE,   matDiffuse);
   glMaterialfv(GL_FRONT, GL_SPECULAR,  matSpecular);
   glMaterialfv(GL_FRONT, GL_SHININESS, matShininess);
   // Color the cube .
   // Build a plate using vertex arrays.
   glBegin(GL_QUADS);		                   
     glNormal3f(0.0, 0.0, 1.0);		// Only need to specify once for a flat surface.
     glTexCoord2f(0.0, 1.0); 		// Bottom Left 
     glVertex3f(-1.0, -1.0,  1.0);	
     glTexCoord2f(1.0, 1.0); 		// Bottom Right 
     glVertex3f( 1.0, -1.0,  1.0);	
     glTexCoord2f(1.0, 0.0); 		// Top Right
     glVertex3f( 1.0,  1.0,  1.0);	
     glTexCoord2f(0.0, 0.0); 		// Top Left 
     glVertex3f(-1.0,  1.0,  1.0);	
   glEnd();
   glBegin(GL_QUADS);		           
     glNormal3f(0.0, 0.0,-1.0);		// Only need to specify once for a flat surface.
     glTexCoord2f(1.0, 1.0); 		// Bottom Right 
     glVertex3f(-1.0, -1.0, -1.0);	
     glTexCoord2f(1.0, 0.0); 		// Top Right
     glVertex3f(-1.0,  1.0, -1.0);	 
     glTexCoord2f(0.0, 0.0); 		// Top Left
     glVertex3f( 1.0,  1.0, -1.0);	 
     glTexCoord2f(0.0, 1.0); 		// Bottom Left
     glVertex3f( 1.0, -1.0, -1.0);	 
   glEnd();
   glBegin(GL_QUADS);		                
     glNormal3f(0.0, 1.0, 0.0);		// Only need to specify once for a flat surface.
     glTexCoord2f(0.0, 0.0); 		// Top Left 
     glVertex3f(-1.0,  1.0, -1.0);	
     glTexCoord2f(0.0, 1.0); 		// Bottom Left
     glVertex3f(-1.0,  1.0,  1.0);	 
     glTexCoord2f(1.0, 1.0); 		// Bottom Right
     glVertex3f( 1.0,  1.0,  1.0);	 
     glTexCoord2f(1.0, 0.0); 		// Top Right
     glVertex3f( 1.0,  1.0, -1.0);	 
   glEnd();
   glBegin(GL_QUADS);	   
     glNormal3f(0.0,-1.0, 0.0);		// Only need to specify once for a flat surface.
     glTexCoord2f(1.0, 0.0); 		// Top Right
     glVertex3f(-1.0, -1.0, -1.0);	 
     glTexCoord2f(0.0, 0.0); 		// Top Left
     glVertex3f( 1.0, -1.0, -1.0);	 
     glTexCoord2f(0.0, 1.0); 		// Bottom Left
     glVertex3f( 1.0, -1.0,  1.0);	 
     glTexCoord2f(1.0, 1.0); 		// Bottom Right
     glVertex3f(-1.0, -1.0,  1.0);	 
   glEnd();
   glBegin(GL_QUADS);
     glNormal3f(1.0, 0.0, 0.0);		// Only need to specify once for a flat surface.
     glTexCoord2f(1.0, 1.0); 		// Bottom Right 
     glVertex3f( 1.0, -1.0, -1.0);	
     glTexCoord2f(1.0, 0.0); 		// Top Right 
     glVertex3f( 1.0,  1.0, -1.0);	
     glTexCoord2f(0.0, 0.0); 		// Top Left 
     glVertex3f( 1.0,  1.0,  1.0);	
     glTexCoord2f(0.0, 1.0); 		// Bottom Left
     glVertex3f( 1.0, -1.0,  1.0);	 
   glEnd();
   glBegin(GL_QUADS);
     glNormal3f(-1.0, 0.0, 0.0);	// Only need to specify once for a flat surface.
     glTexCoord2f(0.0, 1.0); 		// Bottom Left
     glVertex3f(-1.0, -1.0, -1.0);	
     glTexCoord2f(1.0, 1.0); 		// Bottom Right 
     glVertex3f(-1.0, -1.0,  1.0);	
     glTexCoord2f(1.0, 0.0); 		// Top Right 
     glVertex3f(-1.0,  1.0,  1.0);	
     glTexCoord2f(0.0, 0.0); 		// Top Left 
     glVertex3f(-1.0,  1.0, -1.0);	
   glEnd();
   glPopMatrix();
}

/****************************************/
/* Draws static scene.                  */
/****************************************/
void SCENE_DISPLAY(void) {
   glutSetWindow(window);
   SCENE_WINDOW.CLEAR();
   glutSetWindow(vuport);
   glDrawBuffer(GL_BACK);
   glPolygonMode(GL_FRONT, GL_FILL);
   // Hidden surface removal.
   glEnable(GL_CULL_FACE); 
   glEnable(GL_DEPTH_TEST);
   glEnable(GL_NORMALIZE);
   glClear(GL_DEPTH_BUFFER_BIT);
   // Cameras.
   if (cameraD == 1) {
      glLoadIdentity();
      gluLookAt( lightX, lightY, lightZ, 400.0, 350.0, 0.0,   0.0, 1.0, 0.0);
      if (cameraPos == 1) glTranslated(400, 700, 0);	// Required to recenter image.
      if (cameraPos == 2) glTranslated(800, 350, 0);
      if (cameraPos == 3) glTranslated(400, 2800, 0);
      if (cameraPos == 4) glTranslated(3200, 350, 0);
      if (cameraPos == 5) glTranslated(400, 350, 500);

   }
   if (cameraS == 1) {
      glLoadIdentity();
      gluLookAt(1000.0, 0.0, 200.0, 400, 350.0, 0.0, 0.0, 1.0, 0.0);  
      glTranslated(2000,  -700, 300);					// Required to recenter image.
   }
   // Lighting model updates.
   glEnable(GL_LIGHTING);
   if (lightA == 1) glEnable(GL_LIGHT0);
               else glDisable(GL_LIGHT0);
   if (lightD == 1) glEnable(GL_LIGHT1);
               else glDisable(GL_LIGHT1);
   if (lightS == 1) glEnable(GL_LIGHT2);
               else glDisable(GL_LIGHT2);
   // Shader model.
   if (shader == 0) glShadeModel(GL_FLAT);
               else glShadeModel(GL_SMOOTH); 
   DRAW_CUBE1(200, 175, -300, 40);
   DRAW_SPHERE(500, 150, 0, 50);
   if (textures == 1) {
      glEnable(GL_TEXTURE_2D); 
      glBindTexture(GL_TEXTURE_2D, ConeMap);
      glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE); 
   }
   DRAW_CONE(200, 300, -200, 200);
   if (textures == 1) {
      glBindTexture(GL_TEXTURE_2D, RonMap);
      glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL); 
   }
   DRAW_CUBE2(400, 475, -100, 50);
   if (textures == 1) {
      glBindTexture(GL_TEXTURE_2D, EarthMap);
      glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE); 
   }
   DRAW_SPHERE(600, 350, 0, 100);
   if (textures == 1) {
      glBindTexture(GL_TEXTURE_2D, MoonMap);
      glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE); 
   }
   DRAW_SPHERE(100, 450, 0, 50);
   // Disable textures.
   glDisable(GL_TEXTURE_2D); 
   // Disable lighting.
   glDisable(GL_LIGHTING);
   // Disable hidden surfaces (reqd to clear screen).
   glDisable(GL_CULL_FACE); 
   glDisable(GL_DEPTH_TEST);
   // Reset flags and swap buffers.
   glutSwapBuffers();
   glLoadIdentity();
}

/****************************************/
/* Animates objects.                    */
/****************************************/
void SCENE_ANIMATE(void) {
   pAngle += angleStep;
   system("sleep 0.05");
   SCENE_WINDOW.CLEAR();
   SCENE_DISPLAY();
}

/****************************************/
/* Main window display.                 */
/****************************************/
void MAIN_WINDOW(void) {
   glutSetWindow(window);
   glDrawBuffer(GL_BACK);
   glPolygonMode(GL_FRONT, GL_FILL);
   glColor3f(0.6, 0.6, 0.6);
   glBegin(GL_QUADS);
     glVertex2i(       0,         0);
     glVertex2i(winWidth,         0);
     glVertex2i(winWidth, winHeight);
     glVertex2i(       0, winHeight);
   glEnd();
   LITA_BUTTON.DRAW();
   LITS_BUTTON.DRAW();
   CONE_BUTTON.DRAW();
   LITD_BUTTON.DRAW();
   LTDU_BUTTON.DRAW();
   LTDC_BUTTON.DRAW();
   LTDD_BUTTON.DRAW();
   LTDL_BUTTON.DRAW();
   LTDR_BUTTON.DRAW();
   FACE_BUTTON.DRAW();
   MAPS_BUTTON.DRAW();
   SHAD_BUTTON.DRAW();
   ROLL_BUTTON.DRAW();
   CAMS_BUTTON.DRAW();
   CAMD_BUTTON.DRAW();
   EXIT_BUTTON.DRAW_HILITE(0.7, 0.0, 0.0);

xxxP_BUTTON.DRAW();
xxxN_BUTTON.DRAW();

   SCENE_WINDOW.DRAW();
   SCENE_WINDOW.CLEAR();
   glutSwapBuffers();
}

/************************************************************/
/* CALLBACK FUNTIONS.                                       */
/************************************************************/
/****************************************/
/* Mouse control.                       */
/****************************************/
void myMouse(int button, int state, int x, int y) {
   glutSetWindow(window);
   y = (winHeight - y);
   if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN) {
      glFinish();
      // Ambient light.
      if (LITA_BUTTON.SELECTED(x, y)) { 
         LITA_BUTTON.CLICK();
         if (lightA == 0) {
            lightA = 1;
            LIGHT_MODEL(); 
            LITA_BUTTON.DRAW_HILITE(0.7, 0.7, 0.0);
         } else {
            lightA = 0;
            LITA_BUTTON.DRAW();
         }               
         SCENE_WINDOW.CLEAR(); 
         SCENE_DISPLAY();
      }
      // Specular light.
      if (LITS_BUTTON.SELECTED(x, y)) { 
         LITS_BUTTON.CLICK();
         if (lightS == 0) {
            lightS = 1;
            LIGHT_MODEL(); 
            LITS_BUTTON.DRAW_HILITE(0.7, 0.7, 0.0);
         } else {
            lightS = 0;
            LITS_BUTTON.DRAW();
         }       
         SCENE_WINDOW.CLEAR(); 
         SCENE_DISPLAY();
      }
      if (CONE_BUTTON.SELECTED(x, y)) { 
         CONE_BUTTON.CLICK();
         spotWidth += 10;
         if (spotWidth > 45) spotWidth = 5; 
         printf("Spotlight Width: %d\n", spotWidth);
         LIGHT_MODEL();
         SCENE_WINDOW.CLEAR(); 
         SCENE_DISPLAY();
      }
      // Diffuse light.
      if (LITD_BUTTON.SELECTED(x, y)) { 
         LITD_BUTTON.CLICK();
         if (lightD == 0) {
            lightD = 1;
            lightX = 400.0;
            lightY = 1000.0;
            lightZ = 200.0;
            LIGHT_MODEL(); 
            LTDU_BUTTON.DRAW_HILITE(0.7, 0.7, 0.0);
            LITD_BUTTON.DRAW_HILITE(0.7, 0.7, 0.0);
         } else {
            lightD = 0;
            LITD_BUTTON.DRAW();
            LTDL_BUTTON.DRAW();
            LTDU_BUTTON.DRAW();
            LTDC_BUTTON.DRAW();
            LTDD_BUTTON.DRAW();
            LTDR_BUTTON.DRAW();
         }         
         SCENE_WINDOW.CLEAR(); 
         SCENE_DISPLAY();
      }
      if (LTDU_BUTTON.SELECTED(x, y)) { 
         if (lightD == 0) return;
         LTDU_BUTTON.CLICK();
         lightX = 400.0;
         lightY = 1000.0;
         lightZ = 200.0;
         cameraPos = 1;
         LIGHT_MODEL(); 
         LTDL_BUTTON.DRAW();
         LTDU_BUTTON.DRAW_HILITE(0.7, 0.7, 0.0);
         LTDC_BUTTON.DRAW();
         LTDD_BUTTON.DRAW();
         LTDR_BUTTON.DRAW();
         SCENE_WINDOW.CLEAR(); 
         SCENE_DISPLAY();
      }
      if (LTDC_BUTTON.SELECTED(x, y)) { 
         if (lightD == 0) return;
         LTDC_BUTTON.CLICK();
         lightX = 400.0;
         lightY = 350.0;
         lightZ = 5000.0;
         cameraPos = 5;
         LIGHT_MODEL(); 
         LTDL_BUTTON.DRAW();
         LTDU_BUTTON.DRAW();
         LTDC_BUTTON.DRAW_HILITE(0.7, 0.7, 0.0);
         LTDD_BUTTON.DRAW();
         LTDR_BUTTON.DRAW();
         SCENE_WINDOW.CLEAR(); 
         SCENE_DISPLAY();
      }
      if (LTDD_BUTTON.SELECTED(x, y)) { 
         if (lightD == 0) return;
         LTDD_BUTTON.CLICK();
         lightX = 400.0;
         lightY = -1000.0;
         lightZ = 200.0;
         cameraPos = 3;
         LIGHT_MODEL(); 
         LTDD_BUTTON.DRAW();
         LTDU_BUTTON.DRAW();
         LTDC_BUTTON.DRAW();
         LTDD_BUTTON.DRAW_HILITE(0.7, 0.7, 0.0);
         LTDR_BUTTON.DRAW();
         SCENE_WINDOW.CLEAR(); 
         SCENE_DISPLAY();
      }
      if (LTDL_BUTTON.SELECTED(x, y)) { 
         if (lightD == 0) return;
         LTDL_BUTTON.CLICK();
         lightX = -1000.0;
         lightY = 350.0;
         lightZ = 200.0;
         cameraPos = 4;
         LIGHT_MODEL(); 
         LTDL_BUTTON.DRAW_HILITE(0.7, 0.7, 0.0);
         LTDU_BUTTON.DRAW();
         LTDC_BUTTON.DRAW();
         LTDD_BUTTON.DRAW();
         LTDR_BUTTON.DRAW();
         SCENE_WINDOW.CLEAR(); 
         SCENE_DISPLAY();
      }
      if (LTDR_BUTTON.SELECTED(x, y)) { 
         if (lightD == 0) return;
         LTDR_BUTTON.CLICK();
         lightX = 1000.0;
         lightY = 350.0;
         lightZ = 200.0;
         cameraPos = 2;
         LIGHT_MODEL(); 
         LTDL_BUTTON.DRAW();
         LTDU_BUTTON.DRAW();
         LTDC_BUTTON.DRAW();
         LTDD_BUTTON.DRAW();
         LTDR_BUTTON.DRAW_HILITE(0.7, 0.7, 0.0);
         SCENE_WINDOW.CLEAR(); 
         SCENE_DISPLAY();
      }
      // Number of facets.
      if (FACE_BUTTON.SELECTED(x, y)) { 
         FACE_BUTTON.CLICK();
         faces *= 2;
         printf("Facets: %d\n", faces);
         if (faces > 180) faces = 10; 
         SCENE_WINDOW.CLEAR(); 
         SCENE_DISPLAY();
      }
      // Texture mapping.
      if (MAPS_BUTTON.SELECTED(x, y)) { 
         MAPS_BUTTON.CLICK();
         if (textures == 0) {
            textures = 1;
            MAPS_BUTTON.DRAW_HILITE(0.7, 0.7, 0.0);
         } else {
            textures = 0;
            MAPS_BUTTON.DRAW();
         }         
         SCENE_WINDOW.CLEAR(); 
         SCENE_DISPLAY();
      }
      // Smooth shading.
      if (SHAD_BUTTON.SELECTED(x, y)) { 
         SHAD_BUTTON.CLICK();
         if (shader == 0) {
            shader = 1;
            SHAD_BUTTON.DRAW_HILITE(0.7, 0.7, 0.0);
         } else {
            shader = 0;
            SHAD_BUTTON.DRAW();
         }
         SCENE_WINDOW.CLEAR(); 
         SCENE_DISPLAY();
      }
      // Cameras.
      if (CAMS_BUTTON.SELECTED(x, y)) { 
         CAMS_BUTTON.CLICK();
         if (cameraS == 0) {
            cameraS = 1;
            cameraD = 0;
            CAMS_BUTTON.DRAW_HILITE(0.7, 0.7, 0.0);
            CAMD_BUTTON.DRAW();
         } else {
            cameraS = 0;
            CAMS_BUTTON.DRAW();
         }         
         SCENE_WINDOW.CLEAR(); 
         SCENE_DISPLAY();
      }
      if (CAMD_BUTTON.SELECTED(x, y)) { 
         CAMD_BUTTON.CLICK();
         if (cameraD == 0) {
            cameraD = 1;
            cameraS = 0;
            CAMD_BUTTON.DRAW_HILITE(0.7, 0.7, 0.0);
            CAMS_BUTTON.DRAW();
         } else {
            cameraD = 0;
            CAMD_BUTTON.DRAW();
         }         
         SCENE_WINDOW.CLEAR(); 
         SCENE_DISPLAY();
      }
      // Roll.
      if (ROLL_BUTTON.SELECTED(x, y)) { 
         ROLL_BUTTON.CLICK();
         if (idle == 0) {
            glutIdleFunc(SCENE_ANIMATE);
            idle = 1;
            ROLL_BUTTON.DRAW_HILITE(0.7, 0.7, 0.0);
         } else {
            glutIdleFunc(NULL);
            idle = 0;
            ROLL_BUTTON.DRAW();
         }
      }


      if (xxxP_BUTTON.SELECTED(x, y)) { 
         xxxP_BUTTON.CLICK();
         pos += 100.0;
         printf("Position: %lf\n", pos);
         LIGHT_MODEL(); 
         SCENE_WINDOW.CLEAR(); 
         SCENE_DISPLAY();
      }
      if (xxxN_BUTTON.SELECTED(x, y)) { 
         xxxN_BUTTON.CLICK();
         pos -= 100.0;
         printf("Position: %lf\n", pos);
         SCENE_WINDOW.CLEAR(); 
         LIGHT_MODEL(); 
         SCENE_DISPLAY();
      }


      // Exit.
      if (EXIT_BUTTON.SELECTED(x, y)) { 
         EXIT_BUTTON.CLICK();
         glDeleteTextures(1, &ConeMap);
         glDeleteTextures(1, &MoonMap);
         glDeleteTextures(1, &EarthMap);
         glDeleteTextures(1, &RonMap);
         glutDestroyWindow(window);
         exit(0);                   
      }
   }
}

/****************************************/
/* Resizes screen (if required)         */
/****************************************/
void myResize0(int width, int height) {
   // Define main window.
   glutSetWindow(window);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity(); 
   glOrtho(0.0, (GLdouble)winWidth, 0.0, (GLdouble)winHeight, -100.0, 100.0);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity(); 
}

void myResize1(int width, int height) {
   // Define viewport.
   glutSetWindow(vuport);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity(); 
   glOrtho(0.0, (GLdouble)vupWidth, 0.0, (GLdouble)vupHeight, -5000.0, 5000.0);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity(); 
}

/****************************************/
/* Redisplays screen (if required)      */
/****************************************/
void myDisplay0(void) {
   MAIN_WINDOW();
}

void myDisplay1(void) {
   SCENE_WINDOW.CLEAR();
   SCENE_DISPLAY();
}

/****************************************/
/* Initializes OPENGL parameters    	*/
/****************************************/
void myInit(void) {
   glPointSize(1);
   glCullFace(GL_BACK);
   glEnable(GL_CULL_FACE); 
   glEnable(GL_NORMALIZE);
   glEnable(GL_DEPTH_TEST);
   // Define main window.
   glutSetWindow(window);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity(); 
   glOrtho(0.0, (GLdouble)winWidth, 0.0, (GLdouble)winHeight, -100.0, 100.0);
   glMatrixMode(GL_MODELVIEW);
   glClearColor(0.0, 0.0, 0.0, 0.0);
   glClear(GL_COLOR_BUFFER_BIT); 
   // Define viewport.
   glutSetWindow(vuport);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity(); 
   glOrtho(0.0, (GLdouble)vupWidth, 0.0, (GLdouble)vupHeight, -5000.0, 5000.0);
   glMatrixMode(GL_MODELVIEW);
   glClearColor(0.0, 0.0, 0.0, 0.0);
   glClear(GL_COLOR_BUFFER_BIT); 
   glClearDepth(5000.0);
   glClear(GL_DEPTH_BUFFER_BIT);
   // Init texture and light models.
   TEXTURE_MODEL();
}

/************************************************************/
/* MAIN.                                                    */
/************************************************************/
int main(int argc, char **argv) {
   glutInit(&argc, argv) ;
   glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);  
   glutInitWindowSize(winWidth, winHeight);
   glutInitWindowPosition(winXpos, winYpos);
   window = glutCreateWindow("Cone w/ Cameras by R. Marsh.");
   vuport = glutCreateSubWindow(window, vupXpos, vupYpos, vupWidth, vupHeight);
   glutSetWindow(window);
   glutDisplayFunc(myDisplay0);
   glutReshapeFunc(myResize0);
   glutMouseFunc(myMouse);
   glutSetWindow(vuport);
   glutDisplayFunc(myDisplay1);
   glutReshapeFunc(myResize1);
   myInit();
   glutMainLoop();
   return 1;
}
